### Signal

# WebKit2WebExtension WebPage::user-message-received

since: 2.28

#### Declaration

    gboolean
    user_message_received (
      WebKitWebPage* self,
      WebKitUserMessage* message,
      gpointer user_data
    )

#### Description [src]

This signal is emitted when a `WebKitUserMessage` is received from the `WebKitWebView` corresponding to `web_page`. You can reply to the message using webkit_user_message_send_reply().

You can handle the user message asynchronously by calling `g_object_ref()` on `message` and returning `TRUE`. If the last reference of `message` is removed and the message has been replied, the operation in the `WebKitWebView` will finish with error `WEBKIT_USER_MESSAGE_UNHANDLED_MESSAGE`.

Default handler: The default handler is called after the handlers added via `g_signal_connect()`.
Available since: 2.28

#### Parameters

`message`

  Type: `WebKitUserMessage`

  The `WebKitUserMessage` received.

  The data is owned by the caller of the function.

#### Return value

Type: `gboolean`

`TRUE` if the message was handled, or `FALSE` otherwise.